###################################################
### chunk number 1: setOps
###################################################
#line 233 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
op <- options(); utils::str(op) 
options(SweaveSyntax="SweaveSyntaxNoweb")
options(continue=" ")
options(prompt = "R> ")


###################################################
### chunk number 2: load
###################################################
#line 241 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
library(hypred)


###################################################
### chunk number 3: define.genome
###################################################
#line 259 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
genome <- hypredGenome(num.chr = 2, 
                       len.chr = c(1.0, 1.0), 
                       num.snp = 100)


###################################################
### chunk number 4: summary
###################################################
#line 271 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
summary(genome)


###################################################
### chunk number 5: show.random.map
###################################################
#line 278 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
slot(genome, "pos.snp")[1:5] ## pos. of first 5 


###################################################
### chunk number 6: new.map
###################################################
#line 291 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
map <- rep(seq(0, 0.99, by = 0.01 ), 2)
genome <- hypredNewMap(genome, 
                       new.map = map)
                       


###################################################
### chunk number 7: orderly.map
###################################################
#line 297 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
slot(genome, "pos.snp")[1:5] ## pos. of first 5 


###################################################
### chunk number 8: snp.dist
###################################################
#line 304 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
hypredSNPdist(genome, 
              chromosome = 1, 
              SNP1 = 1, 
              SNP2 = 3)              


###################################################
### chunk number 9: qtl.vect
###################################################
#line 329 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
qtl.ids <- c(1, 20, 40, 60, 80,  ## chr. 1
             101, 120, 140, 160, 180)  ## chr. 2


###################################################
### chunk number 10: qtl.vect2
###################################################
#line 334 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
qtl.dom.ids <- c(40,  ## chr. 1
                 140)  ## chr. 2


###################################################
### chunk number 11: qtl.vect3
###################################################
#line 339 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
per.mar.ids <- c(20,  ## chr. 1
                 120)  ## chr. 2


###################################################
### chunk number 12: qtl
###################################################
#line 351 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
genome <- hypredNewQTL(genome, 
                       new.id.add = qtl.ids, 
                       new.id.dom = qtl.dom.ids, 
                       new.id.per.mar = per.mar.ids, 
                       new.eff.add =  rep(1, 10), 
                       new.eff.dom = c(0.5, 0.5)
                       )


###################################################
### chunk number 13: summary2
###################################################
#line 364 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
summary(genome)


###################################################
### chunk number 14: founder
###################################################
#line 382 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
founder1 <- hypredFounder(genome, 
                          prob.snp = 1)[1, ]
founder2 <- hypredFounder(genome, 
                         prob.snp = 1)[2, ]


###################################################
### chunk number 15: gen.founder
###################################################
#line 389 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
founder1[1:5] ## first 5 loci
founder2[1:5] ## first 5 loci


###################################################
### chunk number 16: intro.hypred
###################################################
#line 408 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
set.seed(114)## to see a recomb. event
new.gamete <- hypredRecombine(genome, 
                              genomeA = founder1, 
                              genomeB = founder2, 
                              mutate = TRUE, 
                              mutation.rate.snp = 2.5 * 10^-5, 
                              mutation.rate.qtl = 2.5 * 10^-5, 
                              block = FALSE)


###################################################
### chunk number 17: show.gam
###################################################
#line 419 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
new.gamete[1:20] ## first 20 loci


###################################################
### chunk number 18: pre.all.mat.F2
###################################################
#line 426 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
N <- 250 ## number of individuals
F2 <- matrix(nrow = N * 2, 
             ncol = 200)


###################################################
### chunk number 19: f2
###################################################
#line 433 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
for(i in 1:(N*2))
  {
    F2[i, ] <- hypredRecombine(genome, 
                               genomeA = founder1, 
                               genomeB = founder2, 
                               mutate = TRUE, 
                               mutation.rate.snp = 2.5 * 10^-5, 
                               mutation.rate.qtl = 2.5 * 10^-5, 
                               block = FALSE)
  }


###################################################
### chunk number 20: random.mate.var
###################################################
#line 470 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
G <- 50 ## number of generations

random.mate.pop <- F2 ## identical to the F2 at start
random.mate.pop.temp <- matrix(nrow = N*2, ncol = 200)


###################################################
### chunk number 21: random.mate
###################################################
#line 477 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"

for(generation in 1 : G) ## loop over generations
  {
    gameteIndex1 <- 1 ## indexing variables
    gameteIndex2 <- 2
    for(indiv in 1 : N) ## loop over individuals
      {
        ## gamete 1
        random.mate.pop.temp[gameteIndex1,] <-         
          hypredRecombine(genome,
                          genomeA = random.mate.pop[gameteIndex1,],
                          genomeB = random.mate.pop[gameteIndex2,],
                          mutate = TRUE,
                          mutation.rate.snp = 2.5 * 10^(-5),
                          mutation.rate.qtl = 2.5 * 10^(-5),
                          block = FALSE)
        ## gamete 2
        random.mate.pop.temp[gameteIndex2,] <-         
          hypredRecombine(genome,
                          genomeA = random.mate.pop[gameteIndex1,],
                          genomeB = random.mate.pop[gameteIndex2,],
                          mutate = TRUE,
                          mutation.rate.snp = 2.5 * 10^(-5),
                          mutation.rate.qtl = 2.5 * 10^(-5),
                          block = FALSE)

        ## increment to next individual
        gameteIndex1 <- gameteIndex1 + 2 
        gameteIndex2 <- gameteIndex2 + 2
      } ## end for N
    
    ## permutate
    random.mate.pop <- random.mate.pop.temp[sample(1 : (N * 2)), ]
  } ## end for G


###################################################
### chunk number 22: g.value
###################################################
#line 525 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
g.value <- hypredTruePerformance(genome, 
                                 random.mate.pop, 
                                 DH = FALSE)
summary(g.value)


###################################################
### chunk number 23: varAndmean
###################################################
#line 532 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"

##-------------------------
## compute expected variance and mean

## additive

## purely additive loci
p.add <- (colSums(random.mate.pop)/nrow(random.mate.pop))[qtl.ids[!qtl.ids%in%qtl.dom.ids]]
q.add <- 1 - p.add

var.add <- sum((2*p.add*q.add*1^2))
mean.add <- sum(2*p.add*1)

## additive + dominance loci
p.add.dom <-  (colSums(random.mate.pop)/nrow(random.mate.pop))[qtl.dom.ids]
q.add.dom <-  1 - (colSums(random.mate.pop)/nrow(random.mate.pop))[qtl.dom.ids]

var.add.dom <- sum(2 * p.add.dom * q.add.dom * ((1 + 0.5*(q.add.dom - p.add.dom))^2))
mean.add.dom <- sum(2*p.add.dom*(1 + (1 - p.add.dom ) * 0.5))

## dominance variance
var.dom <- sum((2 * p.add.dom * q.add.dom * 0.5)^2)

## expectations

meanExp <- mean.add + mean.add.dom
varExp <- var.add + var.add.dom + var.dom


###################################################
### chunk number 24: pheno
###################################################
#line 587 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
var.env <- var(g.value)
phen.value <- g.value + rnorm(250, 0,  sqrt(var.env))


###################################################
### chunk number 25: select
###################################################
#line 598 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
index.individual <- which(phen.value == max(phen.value)) 
index.row1 <- index.individual * 2 - 1
index.row2 <- index.individual * 2 
selected <- random.mate.pop[c(index.row1, index.row2), ]


###################################################
### chunk number 26: pre.all.mat.DH
###################################################
#line 609 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
DH <- matrix(nrow = N, 
             ncol = 200)


###################################################
### chunk number 27: DH
###################################################
#line 614 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
for(i in 1:N)
  {
    DH[i, ] <- hypredRecombine(genome, 
                               genomeA = selected[1, ], 
                               genomeB = selected[2, ], 
                               mutate = TRUE, 
                               mutation.rate.snp = 2.5 * 10^-5, 
                               mutation.rate.qtl = 2.5 * 10^-5, 
                               block = FALSE)
  }


###################################################
### chunk number 28: precalc.mean.DH
###################################################
#line 634 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
mean.DH <- mean(hypredTruePerformance(genome, 
                                      DH, 
                                      DH = TRUE))


###################################################
### chunk number 29: QTL.geno
###################################################
#line 643 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
selected[, qtl.ids] ## all QTL
selected[, qtl.dom.ids] ## QTL with dominance

## effect a = 1 times the number of 1 alleles
sum(selected[, qtl.ids] == 1) +
  ## 0.5 if the dominance QTL have genotype 01 or 10 (hence sum = 1)
  (sum(selected[, qtl.dom.ids[1]]) == 1)*0.5 +
  (sum(selected[, qtl.dom.ids[2]]) == 1)*0.5 


###################################################
### chunk number 30: pheno.DH
###################################################
#line 662 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
g.value.DH <- hypredTruePerformance(genome, 
                                    DH, 
                                    DH = TRUE)

phen.value.DH <- g.value.DH + rnorm(250, 0,  sqrt(var.env))


###################################################
### chunk number 31: desg
###################################################
#line 684 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
design.DH <- hypredCode(genome, 
                        genotypes = DH, 
                        DH = TRUE, 
                        type = "012")


###################################################
### chunk number 32: not.per.mar
###################################################
#line 695 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
design.DH[1, 1:5]


###################################################
### chunk number 33: per.mar
###################################################
#line 700 "d:/Rcompile/CRANpkg/local/2.12/hypred/inst/doc/hypred.Rnw"
design.DH[1, 17:21]


